/*
 *  sample_triangle_external_field_2.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */
#define _USR_PARAMETER_   // may be defined in USR_FILE  see solve.C
#define UseAlpha 2
// old starting point at Emin(h=1.5) = plateau (not the best)
//#define StartAlpha  ( 0.5*M_PI)  // for alpha[0]
//#define StartAlpha1 (-0.5*M_PI)  // for alpha[1]
//  better start near minimum  Emin(h=2.5)
#define StartAlpha  ( 0.63*M_PI)  // for alpha[0]
#define StartAlpha1 (-0.17*M_PI)  // for alpha[1]
// bad start near maximum Emax(h=2.5) (step=Pi/8 works for LSUB3, not LSUB4)
// there is a non-converge area for direct iteration around the maximum!
//#define StartAlpha  ( 1.5*M_PI)  // for alpha[0] 2 spins
//#define StartAlpha1 (-0.5*M_PI)  // for alpha[1] 1 spin

#define StepAlpha  (0.125*M_PI)
//#define StepAlpha  (0.015675*M_PI)  // M_PI/64
//#define StepAlpha  (0.001*M_PI)

//#define SearchAlphaMin 0  // compute one value for fixed alpha[]
//#define SearchAlphaMin 1  // raster, start always with x[]=0.00001
#define SearchAlphaMin 2  // walk around, start always with x[]=0.00001

double usr_parameter(int bonds, double alpha)
{
  // condition for triangular AF in external field: both model states
  if (bonds==1 || bonds==2) return alpha;
  return 1.0;
}

double usr_angle(int bonds, int term13, double *alpha, int numalpha)
{
  // add your model specifique parameter here! 
  //  tdelta * H1 + H2 + H3 + ...
  // model state 2 for triangle and kagome lattices in external fields. (high field limit).
  // now for the q=0 kagome state also.

  double returnValue;
  returnValue=0.0;

  if (bonds == 1) {
	  
    // external field term in H on sites 2 and 3
	  
    if (term13==10) returnValue=      sin(alpha[0]);
    if (term13==11) returnValue= -0.5*cos(alpha[0]);
    if (term13==13) returnValue= -0.5*cos(alpha[0]);

  } else if (bonds == 2) {
	
    // external field term in H on site 1

    if (term13==10) returnValue=      sin(alpha[1]);
    if (term13==11) returnValue= -0.5*cos(alpha[1]);
    if (term13==13) returnValue= -0.5*cos(alpha[1]);
	
  } else if (bonds == 3) {

    // nearest-neighbour bonds in H between sites 1->2 and 3->1 (directional)

    if (term13==1) returnValue=            cos(alpha[0]-alpha[1]);
    if (term13==2) returnValue=        0.5*sin(alpha[0]-alpha[1]);
    if (term13==3) returnValue=        0.5*sin(alpha[0]-alpha[1]);
    if (term13==4) returnValue=       -0.5*sin(alpha[0]-alpha[1]);
    if (term13==5) returnValue=       -0.5*sin(alpha[0]-alpha[1]);
    if (term13==6) returnValue= 0.25*( 1.0+cos(alpha[0]-alpha[1]));
    if (term13==7) returnValue= 0.25*( 1.0+cos(alpha[0]-alpha[1]));
    if (term13==8) returnValue= 0.25*(-1.0+cos(alpha[0]-alpha[1]));
    if (term13==9) returnValue= 0.25*(-1.0+cos(alpha[0]-alpha[1]));
	  
  } else if (bonds == 4) {
	
    // nearest-neighbour bonds in H between sites 2->3 (directional)

    if (term13==1) returnValue= 0.5;
    if (term13==6) returnValue= 0.25;
    if (term13==7) returnValue= 0.25;

  } 
	
  return returnValue;
}


/*
 *  sample_triangle_external_field_expectation_2.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_exp_angle(int bonds, int term13, double *alpha, int numalpha)
{
   // add your model specifique parameter here! 
   //  tdelta * H1 + H2 + H3 + ...
   // model state 2 for triangle and kagome lattices in external fields. (high field limit).
   // now for the q=0 kagome state also.
   double returnValue;
   returnValue=0.0;
   if (bonds == 1) {
      // external field term in H on sites 2 and 3
      if (term13==10) returnValue=     sin(alpha[0]);
      if (term13==11) returnValue=-0.5*cos(alpha[0]);
      if (term13==13) returnValue=-0.5*cos(alpha[0]);
   } else if (bonds == 2) {
      // external field term in H on site 1
      if (term13==10) returnValue=     sin(alpha[1]);
      if (term13==11) returnValue=-0.5*cos(alpha[1]);
      if (term13==13) returnValue=-0.5*cos(alpha[1]);
   } 
   return returnValue;
}
